(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["securityAccess"] = factory();
	else
		root["securityAccess"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "Jh84");
/******/ })
/************************************************************************/
/******/ ({

/***/ "/Y4+":
/***/ (function(module, exports) {

module.exports = require("babel-runtime/core-js/promise");

/***/ }),

/***/ "Jh84":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["hasEditAccess"] = hasEditAccess;
/* harmony export (immutable) */ __webpack_exports__["hasDeleteAccess"] = hasDeleteAccess;
/* harmony export (immutable) */ __webpack_exports__["hasAdminAccess"] = hasAdminAccess;
/* harmony export (immutable) */ __webpack_exports__["hasConfigureAccess"] = hasConfigureAccess;
/* harmony export (immutable) */ __webpack_exports__["checkAuth"] = checkAuth;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_babel_runtime_core_js_promise__ = __webpack_require__("/Y4+");
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_babel_runtime_core_js_promise___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_babel_runtime_core_js_promise__);

function hasActivityEditAccess(roleEditAccess, currentUser, access, teams, myTeams, activity) {
  if (!access) {
    return false;
  }
  if (!activity || !activity.status) {
    return access[roleEditAccess];
  }

  if (activity.status === 'Sent for approval' && activity.assigned_to === currentUser.key && access['approveAccess']) {
    return true;
  }

  if (!access[roleEditAccess] || activity.status === 'Completed') {
    return false;
  }

  var myTeamIds = myTeams ? myTeams.map(function (t) {
    return t.oid;
  }) : [];
  var isTeamMember = myTeamIds.indexOf(activity.assigned_to_team) >= 0;

  if ((activity.status === 'Proposed' || activity.status === 'Planned') && (!activity.assigned_to || activity.assigned_to === 'Unassigned') && isTeamMember) {
    return true;
  }
  var isTeamLeader = false;
  if (activity.assigned_to_team) {
    var responsibleTeam = teams ? teams.filter(function (t) {
      return t.oid === activity.assigned_to_team;
    }) : null;
    var teamLeader = responsibleTeam && responsibleTeam.length === 1 ? responsibleTeam[0].responsibleUserName : null;
    if (teamLeader && teamLeader === currentUser.key) {
      isTeamLeader = true;
    }
  }

  if (activity.assigned_to === currentUser.key || activity.registered_by === currentUser.key || isTeamLeader) {
    return true;
  }

  return false;
}

function hasApproveAccess(roleEditAccess, currentUser, access, activity) {
  if (!access) {
    return false;
  }
  if (!activity || !activity.status) {
    return access[roleEditAccess];
  }
  if (activity.status === 'Sent for approval' && activity.assigned_to === currentUser.key && access['approve']) {
    return true;
  }
  return false;
}

function hasActivityDeleteAccess(roleDeleteAccess, currentUser, access, teams, activity) {
  if (!access) {
    return false;
  }
  if (hasAdminAccess(access)) {
    return true;
  }

  if (!activity || !activity.status) {
    return access[roleDeleteAccess];
  }

  if (!access[roleDeleteAccess] || activity.status === 'Completed') {
    return false;
  }

  var isTeamLeader = false;
  if (activity.assigned_to_team) {
    var responsibleTeam = teams.filter(function (t) {
      return t.oid === activity.assigned_to_team;
    });
    var teamLeader = responsibleTeam && responsibleTeam.length === 1 ? responsibleTeam[0].responsibleUserName : null;
    if (teamLeader && teamLeader === currentUser.key) {
      isTeamLeader = true;
    }
  }

  if (activity.assigned_to === currentUser.key || activity.registered_by === currentUser.key || isTeamLeader) {
    return true;
  }
  return false;
}

function hasActivityTemplateEditAccess(roleEditAccess, currentUser, access, teams, myTeams, activityTemplate) {
  // only requires roleEditAccess
  return access[roleEditAccess];
}

function hasActivityTemplateDeleteAccess(roleDeleteAccess, currentUser, access, myTeams, activityTemplate) {
  // only requires roleDeleteAccess
  return hasAdminAccess(access) || access[roleDeleteAccess];
}

function hasEditAccessGen(roleAccessRequested, access) {
  return hasAdminAccess(access) || access[roleAccessRequested];
}

function hasDeleteAccessGen(roleAccessRequested, access) {
  return hasAdminAccess(access) || access[roleAccessRequested];
}

function hasEditAccess(roleEditAccess, currentUser, access, teams, myTeams, item) {
  switch (roleEditAccess) {
    case 'approveAccess':
      return hasApproveAccess(roleEditAccess, currentUser, access, item);
    case 'integrityActivityEditAccess':
    case 'workOrderEditAccess':
    case 'qraEditAccess':
    case 'threatAssessmentEditAccess':
    case 'riskAssessmentEditAccess':
    case 'analyticalAssessmentEditAccess':
      return hasActivityEditAccess(roleEditAccess, currentUser, access, teams, myTeams, item);
    case 'activityTemplateEditAccess':
      return hasActivityTemplateEditAccess(roleEditAccess, currentUser, access, teams, myTeams, item);
    case 'importMappingEditAccess':
    case 'importMappingsEditAccess':
    case 'anomalyEditAccess':
    case 'activityResultEditAccess':
    case 'activityMethodPropEditAccess':
    case 'userEditAccess':
    case 'teamEditAccess':
    case 'riskAnalysisCompEditAccess':
    case 'companyThreatEditAccess':
    case 'masterPlanEditAccess':
    case 'riskAssessmentResultEditAccess':
    case 'configStoreEditAccess':
    case 'reportingEditAccess':
    case 'threatSetupEditAccess':
    case 'apiAssessmentEditAccess':
    case 'apiAssessmentDefEditAccess':
    case 'anomalyFinderEditAccess':
    case 'apiAssessmentAdapterEditAccess':
    case 'dataViewerViewEditAccess':
    case 'dataLoadEditAccess':
    case 'featureToggleEditAccess':
    case 'dataCollectionEditAccess':
      return hasEditAccessGen(roleEditAccess, access);
    default:
      return false;
  }
}

function hasDeleteAccess(roleDeleteAccess, currentUser, access, myTeams, item) {
  switch (roleDeleteAccess) {
    case 'integrityActivityDeleteAccess':
    case 'workOrderDeleteAccess':
    case 'qraDeleteAccess':
    case 'threatAssessmentDeleteAccess':
    case 'riskAssessmentDeleteAccess':
    case 'analyticalAssessmentDeleteAccess':
      return hasActivityDeleteAccess(roleDeleteAccess, currentUser, access, myTeams, item);
    case 'activityTemplateDeleteAccess':
      return hasActivityTemplateDeleteAccess(roleDeleteAccess, currentUser, access, myTeams, item);
    case 'importMappingDeleteAccess':
    case 'importMappingsDeleteAccess':
    case 'anomalyDeleteAccess':
    case 'activityResultDeleteAccess':
    case 'activityMethodPropDeleteAccess':
    case 'userDeleteAccess':
    case 'teamDeleteAccess':
    case 'riskAnalysisCompDeleteAccess':
    case 'companyThreatDeleteAccess':
    case 'masterPlanDeleteAccess':
    case 'riskAssessmentResultDeleteAccess':
    case 'configStoreDeleteAccess':
    case 'reportingDeleteAccess':
    case 'threatSetupDeleteAccess':
    case 'apiAssessmentDeleteAccess':
    case 'apiAssessmentDefDeleteAccess':
    case 'anomalyFinderDeleteAccess':
    case 'apiAssessmentAdapterDeleteAccess':
    case 'dataViewerViewDeleteAccess':
    case 'dataLoadDeleteAccess':
    case 'featureToggleDeleteAccess':
      return hasDeleteAccessGen(roleDeleteAccess, access);
    default:
      return false;
  }
}

function hasAdminAccess(access) {
  if (!access) {
    return false;
  }
  return access.admin;
}

function hasConfigureAccess(access) {
  if (!access) {
    return false;
  }
  return access.configure;
}

function checkAuth(store, to, from, next, roleKeys) {
  var getters = store.getters;

  var promises = [store.dispatch('fetchCurrentUser'), store.dispatch('fetchAccess')];

  __WEBPACK_IMPORTED_MODULE_0_babel_runtime_core_js_promise___default.a.all(promises).then(function () {
    var hasAccess = false;
    if (hasAdminAccess(getters.access)) {
      hasAccess = true;
    } else if (roleKeys || Array.isArray(roleKeys)) {
      roleKeys.forEach(function (key) {
        if (getters.access[key]) {
          hasAccess = true;
        }
      });
    }
    if (hasAccess) {
      next();
    } else {
      window.location = '/Pages/AuthorizeError.aspx';
    }
  });
}

/***/ })

/******/ });
});